﻿/*Copyright (C) 2015
Anthony Delaune
Laboratoire GPM UMR CNRS 6634 Equipe NanoCARE
Université de Rouen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
/* sun2win32 : opens an old version im file (16 bit sun format) and converts it to 32 bit im win*/
/* anthony delaune 13dec2017 */
/* Warning, only works for square images (no difference between raster line and column*/        

int main(int argc, char *argv[])
{
  FILE *fp;
  FILE *fout;
   int nbmass=0;
   int nbplan=0;
  int header_size=0,  i=0, j=0, k=0, l=0, raster=0, depth=0;
  short a=0, b=0;
  char nom_mass[5][8]= {};
   int offset=0;
   int offset_write=0;
  char nomfich[300]={};
  long int image=0; 
 
 if (argc<2)
 {
	printf("Erreur pas d'argument\n");
	return 0;
 }

  printf("%s\n", argv[1]);
  fp=fopen(argv[1], "rb");
  fflush(fp);
  sprintf(nomfich, "WIN_%s",argv[1]);
  fout=fopen(nomfich, "wb");
  fflush(fout);
  fseek(fp, 411, SEEK_SET);//specific 32bit
 fread(&nbmass, 1, 1, fp);
fseek(fout, 408, SEEK_SET);
fwrite(&nbmass, 1, 1, fout);
  printf("nb de masses : %d\n", nbmass); //number of masses  
 
 for (i=0; i<nbmass; i++)
  {
      fseek(fp, 517+i*192, SEEK_SET);
      fread(&nom_mass[i], 7, 1, fp);  
      
      printf("nom de la masse %d : %s\n", i+1, nom_mass[i]); //mass names
      if (!strcmp(nom_mass[i],""))
      {
      printf("vide\n");
      sprintf(nom_mass[i], "masse_%d", i+1);
      }
      
      printf("nom de la masse %d : %s\n", i+1, nom_mass[i]); //mass names
            
      fseek(fout, 717+i*192, SEEK_SET);
      fwrite(&nom_mass[i], 7, 1, fout);
  }

fseek(fp, 10, SEEK_SET); 
fread(&a, 1, 1, fp);
fread(&b, 1, 1, fp);
header_size=a*256+b;
fseek(fout, 8, SEEK_SET);
fwrite(&header_size, 2, 1, fout);  
printf("taille du header : %d\n", header_size);

//number of plans
fseek(fp, header_size-69, SEEK_SET);//specific 32bit
fread(&nbplan, 1, 1, fp);
fseek(fout, header_size-70, SEEK_SET);
fwrite(&nbplan, 1, 1, fout);
printf("nb de plans : %d\n", nbplan);

//raster
fseek(fp, header_size-78, SEEK_SET);//specific 32bit
fread(&a, 1, 1, fp);
fread(&b, 1, 1, fp);
fseek(fout, header_size-78, SEEK_SET);
fwrite(&b, 1, 1, fout);
fwrite(&a, 1, 1, fout);
raster=a*256+b;

printf("largeur : %d\n", raster);
fseek(fp, header_size-76, SEEK_SET);
fread(&a, 1, 1, fp);
fread(&b, 1, 1, fp);
fseek(fout, header_size-76, SEEK_SET);
fwrite(&b, 1, 1, fout);
fwrite(&a, 1, 1, fout);
printf("hauteur : %d\n", a*256+b);
fseek(fp, header_size-73, SEEK_SET);
fread(&depth, 1, 1, fp);

fseek(fout, header_size-74, SEEK_SET);
fwrite(&depth, 1, 1, fout);
printf("profondeur pixel : %d\n", depth);

fseek(fp, header_size-66, SEEK_SET);//specific 32bit
fread(&a, 1, 1, fp);
fread(&b, 1, 1, fp);
fseek(fout, header_size-68, SEEK_SET);
fwrite(&b, 1, 1, fout);
fwrite(&a, 1, 1, fout);
printf("raster (nm): %d\n", a*256+b);

fseek(fp, header_size-71, SEEK_SET);
fread(&a, 1, 1, fp);
fseek(fout, header_size-72, SEEK_SET);
fwrite(&a, 1, 1, fout);

//reading images and filling tables
fflush(fp);
fseek(fp, header_size, SEEK_SET);
fflush(fout);
fseek(fout, header_size, SEEK_SET);      
     
for (i=0; i<nbplan; i++)
    {
    for (j=0; j<nbmass; j++)
     {
       for (k=0; k<raster; k++)
        {
               for (l=0; l<raster; l++)
        {
              fseek(fp, header_size+offset, SEEK_SET);
	      fread(&a, 1, 1, fp);
	      fread(&b, 1, 1, fp);
              fseek(fout, header_size+offset_write, SEEK_SET);
              image=a*256+b;
              fwrite(&image, 2, 1, fout);
              offset=offset+2;
	      offset_write=offset_write+4;
             fflush(fp);
              fflush(fout);
              }
        }    
     }      
    }
fclose(fp); 
fclose(fout);
return(1);
}