﻿/*
Copyright (C) 2012
Anthony Delaune
Laboratoire GPM UMR CNRS 6634 Equipe NanoCARE
Université de Rouen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
/* opens an im station window file, reads the header and exports to an im SUN compatible file*/
/* anthony delaune 2012 */        



int main(int argc, char *argv[])
{
  FILE *fp;
  FILE *fout;
   int nbmass=0;
   int nbplan=0;
  int header_size=0,  i=0, j=0, k=0, l=0, raster=0, depth=0;
  short a=0, b=0;
  char nom_mass[5][8]= {};
   int offset=0;
  char nomfich[300]={};
  long int image=0; 
 
 if (argc<2)
 {
	printf("Erreur pas d'argument\n");
	return 0;
 }

  printf("%s\n", argv[1]);
  fp=fopen(argv[1], "rb");
  fflush(fp);

  sprintf(nomfich, "SUN_%s",argv[1]);
  fout=fopen(nomfich, "wb");
  fflush(fout);


  fseek(fp, 408, SEEK_SET);//specific win
 fread(&nbmass, 1, 1, fp);
fseek(fout, 411, SEEK_SET);
fwrite(&nbmass, 1, 1, fout);


  printf("nb de masses : %d\n", nbmass); //number of masses  
 
 for (i=0; i<nbmass; i++)
  {
      fseek(fp, 717+i*192, SEEK_SET);
      fread(&nom_mass[i], 7, 1, fp);  
      
      
      
      
      printf("nom de la masse %d : %s\n", i+1, nom_mass[i]); //mass names
      if (!strcmp(nom_mass[i],""))
      {
      printf("vide\n");
      sprintf(nom_mass[i], "masse_%d", i+1);
      }
      
      
      printf("nom de la masse %d : %s\n", i+1, nom_mass[i]); //mass names
      
      
      fseek(fout, 517+i*192, SEEK_SET);
      fwrite(&nom_mass[i], 7, 1, fout);
  
  
}

fseek(fp, 8, SEEK_SET); //specific win

fread(&header_size, 2, 1, fp);  // 16bit reading//specific win
b=fmod(header_size, 256);
a=(header_size-b)/256;
fseek(fout, 10, SEEK_SET);
fwrite(&a, 1, 1, fout);
fwrite(&b, 1, 1, fout);

printf("taille du header : %d\n", header_size);


//number of plans
fseek(fp, header_size-70, SEEK_SET);//specific win
fread(&nbplan, 1, 1, fp);

fseek(fout, header_size-69, SEEK_SET);
fwrite(&nbplan, 1, 1, fout);

printf("nb de plans : %d\n", nbplan);

//raster
fseek(fp, header_size-78, SEEK_SET);//specific win
fread(&a, 1, 1, fp);
fread(&b, 1, 1, fp);
fseek(fout, header_size-78, SEEK_SET);
fwrite(&b, 1, 1, fout);
fwrite(&a, 1, 1, fout);
raster=b*256+a;

printf("largeur : %d\n", raster);
fseek(fp, header_size-76, SEEK_SET);//specific win
fread(&a, 1, 1, fp);
fread(&b, 1, 1, fp);

fseek(fout, header_size-76, SEEK_SET);
fwrite(&b, 1, 1, fout);
fwrite(&a, 1, 1, fout);
printf("hauteur : %d\n", b*256+a);
fseek(fp, header_size-74, SEEK_SET);//specific win
fread(&depth, 1, 1, fp);

fseek(fout, header_size-73, SEEK_SET);
fwrite(&depth, 1, 1, fout);

printf("profondeur pixel : %d\n", depth);
fseek(fp, header_size-68, SEEK_SET);//specific win
fread(&a, 1, 1, fp);
fread(&b, 1, 1, fp);
fseek(fout, header_size-66, SEEK_SET);
fwrite(&b, 1, 1, fout);
fwrite(&a, 1, 1, fout);
printf("raster (nm): %d\n", b*256+a);

fseek(fp, header_size-72, SEEK_SET);
fread(&a, 1, 1, fp);
fseek(fout, header_size-71, SEEK_SET);
fwrite(&a, 1, 1, fout);


//reading images and filling tables
fflush(fp);
fseek(fp, header_size, SEEK_SET);
fflush(fout);
fseek(fout, header_size, SEEK_SET);      
     
for (i=0; i<nbplan; i++)
    {
    for (j=0; j<nbmass; j++)
     {
     
       for (k=0; k<raster; k++)
        {
               for (l=0; l<raster; l++)
        {

              fseek(fp, header_size+offset, SEEK_SET);
              fread(&image, 2, 1, fp);//specific win 16bit reading
              
              fseek(fout, header_size+offset, SEEK_SET);
              b=fmod(image, 256);
              a=(image-b)/256;
              
              fwrite(&a, 1, 1, fout);
              fwrite(&b, 1, 1, fout);
              
              offset=offset+2;

              
              fflush(fp);
              fflush(fout);
              }
              
             
        }    
        
     }      
    }
fclose(fp); 
fclose(fout);
    
  return(1);
}
